
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                             
C     Parallel Random Surfaces Simulation       
C     Version 0.0  (June 1993)                 
C     Kivanc Dincer                                
C                                               
C     Regular code, with 4-coloring scheme 
C     F77 + cmmd 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      PROGRAM  init
      INCLUDE "def.h"
      INCLUDE "array.h"
      INCLUDE 'random.h'

      REAL xtmp1(half_ny, 0:half_nx+1) 
      REAL xtmp2(half_ny, 0:half_nx+1) 
      REAL xtmp3(half_ny, 0:half_nx+1) 
      REAL xtmp4(half_ny, 0:half_nx+1) 
      REAL ytmp1(half_ny, 0:half_nx+1) 
      REAL ytmp2(half_ny, 0:half_nx+1) 
      REAL ytmp3(half_ny, 0:half_nx+1) 
      REAL ytmp4(half_ny, 0:half_nx+1) 
      REAL ztmp1(half_ny, 0:half_nx+1) 
      REAL ztmp2(half_ny, 0:half_nx+1) 
      REAL ztmp3(half_ny, 0:half_nx+1) 
      REAL ztmp4(half_ny, 0:half_nx+1) 

      INTEGER i,j
      integer seed1, seed2 

      gauss = 0.0
      tag = 0
      len = 4*gny
      ret_stat = cmmd_partition_size()
      print *, "partition size=",ret_stat
      print *, "mesh size = ", nx, ' x ', ny

C     ret_stat = CMMD_set_io_mode(6, CMMD_independent)

      my_pnum = cmmd_self_address()
      west  = my_pnum-1
      if (west .lt. 0) west = west + numproc
      east  = mod(my_pnum+1, numproc)
C     print *, my_pnum, west, east
      ret_stat = cmmd_node_timer_clear(0)
      ret_stat = cmmd_node_timer_start(0)

      print *, "sweeps OK"
c      read *, sweeps

      print *, "seed OK"
c      read *, seed
      seed1 = 1213
      seed2 = my_pnum
      sweeps = 10

      call rmarin(seed1, seed2)

      call RANDOM(xt1)
      call RANDOM(yt1)
      call RANDOM(zt1)
      call RANDOM(xt2)
      call RANDOM(yt2)
      call RANDOM(zt2)
      call RANDOM(xt3)
      call RANDOM(yt3)
      call RANDOM(zt3)
      call RANDOM(xt4)
      call RANDOM(yt4)
      call RANDOM(zt4)
C     print *, "CMF_Randoms OK"

C-------------------------------------
C     Perform communications
C-------------------------------------
      call communicate(west, east, xt1, xt2, xt3, xt4)
      call communicate(east, west, xt1, xt2, xt3, xt4)

      call communicate(west, east, yt1, yt2, yt3, yt4)
      call communicate(east, west, yt1, yt2, yt3, yt4)

      call communicate(west, east, zt1, zt2, zt3, zt4)
      call communicate(east, west, zt1, zt2, zt3, zt4)
     
C-------------------------
C     Type 1               There are some errors in Han's code
C------------------------- I have fixed them. 
      call cshift(xt2, 2, -1, xtmp1)
      call cshift(xt3, 1, -1, xtmp2)
      call cshift(xt4, 2, -1, xtmp3)
      call cshift(xtmp3, 1, -1, xtmp3)
      call cshift(yt2, 2, -1, ytmp1)
      call cshift(yt3, 1, -1, ytmp2)
      call cshift(yt4, 2, -1, ytmp3)
      call cshift(ytmp3, 1, -1, ytmp3)
      call cshift(zt2, 2, -1, ztmp1)
      call cshift(zt3, 1, -1, ztmp2)
      call cshift(zt4, 2, -1, ztmp3)
      call cshift(ztmp3, 1, -1, ztmp3)

      do i = 1, gny
         do j = 1, half_nx
            t1(i,j) = (xt1(i,j) - xt2(i,j))**2 + 
     .                (yt1(i,j) - yt2(i,j))**2 + 
     .                (zt1(i,j) - zt2(i,j))**2 +
     .                (xt1(i,j) - xt3(i,j))**2 + 
     .                (yt1(i,j) - yt3(i,j))**2 + 
     .                (zt1(i,j) - zt3(i,j))**2 +
     .                (xt1(i,j) - xt4(i,j))**2 + 
     .                (yt1(i,j) - yt4(i,j))**2 + 
     .                (zt1(i,j) - zt4(i,j))**2 +
     .                (xt1(i,j)-xtmp1(i,j))**2 + 
     .                (yt1(i,j)-ytmp1(i,j))**2 + 
     .                (zt1(i,j)-ztmp1(i,j))**2 +
     .                (xt1(i,j)-xtmp2(i,j))**2 + 
     .                (yt1(i,j)-ytmp2(i,j))**2 + 
     .                (zt1(i,j)-ztmp2(i,j))**2 +
     .                (xt1(i,j)-xtmp3(i,j))**2 + 
     .                (yt1(i,j)-ytmp3(i,j))**2 + 
     .                (zt1(i,j)-ztmp3(i,j))**2
         enddo
      enddo
C-------------------------
C     Type 2
C-------------------------Again some errors
      call cshift(xt1, 2, +1, xtmp1)
      call cshift(xt4, 1, -1, xtmp2)
      call cshift(xt3, 2, -1, xtmp3)
      call cshift(xtmp3, 1, -1, xtmp3)
      call cshift(xt3, 2, +1, xtmp4)
      call cshift(xtmp4, 1, +1, xtmp4)

      call cshift(yt1, 2, +1, ytmp1)
      call cshift(yt4, 1, -1, ytmp2)
      call cshift(yt3, 2, -1, ytmp3)
      call cshift(ytmp3, 1, -1, ytmp3)
      call cshift(yt3, 2, +1, ytmp4)
      call cshift(ytmp4, 1, +1, ytmp4)

      call cshift(zt1, 2, +1, ztmp1)
      call cshift(zt4, 1, -1, ztmp2)
      call cshift(zt3, 2, -1, ztmp3)
      call cshift(ztmp3, 1, -1, ztmp3)
      call cshift(zt3, 2, +1, ztmp4)
      call cshift(ztmp4, 1, +1, ztmp4)

      do i = 1, gny
         do j = 1, half_nx
            t2(i,j) = (xt2(i,j) - xt1(i,j))**2 + 
     .                (yt2(i,j) - yt1(i,j))**2 + 
     .                (zt2(i,j) - zt1(i,j))**2 +
     .                (xt2(i,j) - xt4(i,j))**2 + 
     .                (yt2(i,j) - yt4(i,j))**2 + 
     .                (zt2(i,j) - zt4(i,j))**2 +
     .                (xt2(i,j) - xt1(i,j))**2 + 
     .                (yt2(i,j) - yt1(i,j))**2 + 
     .                (zt2(i,j) - zt1(i,j))**2 +
     .                (xt2(i,j)-xtmp2(i,j))**2 + 
     .                (yt2(i,j)-ytmp2(i,j))**2 + 
     .                (zt2(i,j)-ztmp2(i,j))**2 +
     .                (xt2(i,j)-xtmp3(i,j))**2 + 
     .                (yt2(i,j)-ytmp3(i,j))**2 + 
     .                (zt2(i,j)-ztmp3(i,j))**2 +
     .                (xt2(i,j)-xtmp4(i,j))**2 + 
     .                (yt2(i,j)-ytmp4(i,j))**2 + 
     .                (zt2(i,j)-ztmp4(i,j))**2
         enddo
      enddo
C-------------------------
C     Type 3
C-------------------------Again some errors
      call cshift(xt4, 2, -1, xtmp1)
      call cshift(xt1, 1, +1, xtmp2)
      call cshift(xt2, 2, -1, xtmp3)
      call cshift(xtmp3, 1, -1, xtmp3)
      call cshift(xt2, 2, +1, xtmp4)
      call cshift(xtmp4, 1, +1, xtmp4)

      call cshift(yt4, 2, -1, ytmp1)
      call cshift(yt1, 1, +1, ytmp2)
      call cshift(yt2, 2, -1, ytmp3)
      call cshift(ytmp3, 1, -1, ytmp3)
      call cshift(yt2, 2, +1, ytmp4)
      call cshift(ytmp4, 1, +1, ytmp4)

      call cshift(zt4, 2, -1, ztmp1)
      call cshift(zt1, 1, +1, ztmp2)
      call cshift(zt2, 2, -1, ztmp3)
      call cshift(ztmp3, 1, -1, ztmp3)
      call cshift(zt2, 2, +1, ztmp4)
      call cshift(ztmp4, 1, +1, ztmp4)

      do i = 1, gny
         do j = 1, half_nx
            t3(i,j) = (xt3(i,j) - xt1(i,j))**2 + 
     .                (yt3(i,j) - yt1(i,j))**2 + 
     .                (zt3(i,j) - zt1(i,j))**2 +
     .                (xt3(i,j) - xt4(i,j))**2 + 
     .                (yt3(i,j) - yt4(i,j))**2 + 
     .                (zt3(i,j) - zt4(i,j))**2 +
     .                (xt3(i,j) - xt1(i,j))**2 + 
     .                (yt3(i,j) - yt1(i,j))**2 + 
     .                (zt3(i,j) - zt1(i,j))**2 +
     .                (xt3(i,j)-xtmp2(i,j))**2 + 
     .                (yt3(i,j)-ytmp2(i,j))**2 + 
     .                (zt3(i,j)-ztmp2(i,j))**2 +
     .                (xt3(i,j)-xtmp3(i,j))**2 + 
     .                (yt3(i,j)-ytmp3(i,j))**2 + 
     .                (zt3(i,j)-ztmp3(i,j))**2 +
     .                (xt3(i,j)-xtmp4(i,j))**2 + 
     .                (yt3(i,j)-ytmp4(i,j))**2 + 
     .                (zt3(i,j)-ztmp4(i,j))**2
         enddo
      enddo
C-------------------------
C     Type 4
C-------------------------Some other errors
      call cshift(xt3, 2, +1, xtmp1)
      call cshift(xt2, 1, +1, xtmp2)
      call cshift(xt1, 2, +1, xtmp3)
      call cshift(xtmp3, 1, +1, xtmp3)

      call cshift(yt3, 2, +1, ytmp1)
      call cshift(yt2, 1, +1, ytmp2)
      call cshift(yt1, 2, +1, ytmp3)
      call cshift(ytmp3, 1, +1, ytmp3)

      call cshift(zt3, 2, +1, ztmp1)
      call cshift(zt2, 1, +1, ztmp2)
      call cshift(zt1, 2, +1, ztmp3)
      call cshift(ztmp3, 1, +1, ztmp3)

      do i = 1, gny
         do j = 1, half_nx
            t4(i,j) = (xt4(i,j) - xt3(i,j))**2 + 
     .                (yt4(i,j) - yt3(i,j))**2 + 
     .                (zt4(i,j) - zt3(i,j))**2 +
     .                (xt4(i,j) - xt2(i,j))**2 + 
     .                (yt4(i,j) - yt2(i,j))**2 + 
     .                (zt4(i,j) - zt2(i,j))**2 +
     .                (xt4(i,j) - xt1(i,j))**2 + 
     .                (yt4(i,j) - yt1(i,j))**2 + 
     .                (zt4(i,j) - zt1(i,j))**2 +
     .                (xt4(i,j)-xtmp1(i,j))**2 + 
     .                (yt4(i,j)-ytmp1(i,j))**2 + 
     .                (zt4(i,j)-ztmp1(i,j))**2 +
     .                (xt4(i,j)-xtmp2(i,j))**2 + 
     .                (yt4(i,j)-ytmp2(i,j))**2 + 
     .                (zt4(i,j)-ztmp2(i,j))**2 +
     .                (xt4(i,j)-xtmp3(i,j))**2 + 
     .                (yt4(i,j)-ytmp3(i,j))**2 + 
     .                (zt4(i,j)-ztmp3(i,j))**2
         enddo
      enddo

      ret_stat = cmmd_node_timer_stop(0)
      print 7, cmmd_node_timer_busy(0)
  7   format(1x, 'init. busy time =', f8.4)

      ret_stat = cmmd_node_timer_clear(0)
      ret_stat = cmmd_node_timer_start(0)
      DO i = 1, sweeps
        call update_sites
        call measure
      END DO

      ret_stat = cmmd_node_timer_stop(0)
      print 9, sweeps, cmmd_node_timer_busy(0)
 9    format(1x, 'update (busy)time for ', i3, ' sweeps=', f8.4)

      gauss = gauss/sweeps
      print *, gauss

      STOP
      END

C **************************************************************************
      SUBROUTINE rmarin(ij,kl)
C This is the initialization routine for the random number generator
C     RANMAR()
C NOTE: The seed variables can have values between:    0 <= IJ <= 31328
C                                                      0 <= KL <= 30081
      REAL u(97), c, cd, cm
      INTEGER i97, j97, ivec
      LOGICAL test
      COMMON /raset1/ u, c, cd, cm, i97, j97, ivec, test

      IF( ij .LT. 0  .OR.  ij .GT. 31328  .OR.
     *    kl .LT. 0  .OR.  kl .GT. 30081 ) THEN
        PRINT '(A)', ' The first random number seed must have a value
     *between 0 and 31328'
        PRINT '(A)',' The second seed must have a value between 0 and
     *30081'
        STOP
      ENDIF
      i = mod(ij/177, 177) + 2
      j = mod(ij    , 177) + 2
      k = mod(kl/169, 178) + 1
      l = mod(kl,     169)
      DO 2 ii = 1, 97
        s = 0.0
        t = 0.5
        DO 3 jj = 1, 24
          m = mod(mod(i*j, 179)*k, 179)
          i = j
          j = k
          k = m
          l = mod(53*l+1, 169)
          IF (mod(l*m, 64) .ge. 32) then
            s = s + t
          ENDIF
          t = 0.5 * t
    3   CONTINUE
        u(ii) = s
    2 CONTINUE
      c = 362436.0 / 16777216.0
      cd = 7654321.0 / 16777216.0
      cm = 16777213.0 /16777216.0
      i97 = 97
      j97 = 33
      test = .true.
      RETURN
      END
C **************************************************************************
C **************************************************************************
      FUNCTION ranmar()
      IMPLICIT NONE
      REAL rand_u(97), rand_c, rand_cd, rand_cm, rand_uni, ranmar
      INTEGER rand_i97, rand_j97, rand_ivec
      LOGICAL rand_test
      COMMON /raset1/ rand_u, rand_c, rand_cd, rand_cm, rand_i97
     $     , rand_j97, rand_ivec, rand_test

      IF( .NOT. rand_test ) THEN
        PRINT '(A)',' Call the init routine (RMARIN) before calling RAN
     *MAR'
        STOP
      ENDIF
      rand_uni = rand_u(rand_i97) - rand_u(rand_j97)
      IF( rand_uni .LT. 0.0 ) rand_uni = rand_uni + 1.0
      rand_u(rand_i97) = rand_uni
      rand_i97 = rand_i97 - 1
      IF(rand_i97 .EQ. 0) rand_i97 = 97
      rand_j97 = rand_j97 - 1
      IF(rand_j97 .EQ. 0) rand_j97 = 97
      rand_c = rand_c - rand_cd
      IF( rand_c .LT. 0.0 ) rand_c = rand_c + rand_cm
      rand_uni = rand_uni - rand_c
      IF( rand_uni .LT. 0.0 ) rand_uni = rand_uni + 1.0
      ranmar = rand_uni
      RETURN
      END
C **************************************************************************

      BLOCK DATA
      REAL u(97), c, cd, cm
      INTEGER i97, j97, ivec
      LOGICAL test
      COMMON /raset1/ u, c, cd, cm, i97, j97, ivec, test
      DATA test /.false./
      END

      subroutine RANDOM(x)
      include 'def.h'
      include 'random.h'
      real x(half_ny, 0:half_nx+1)
      integer i, j 
      real ranmar

      do i = 1, half_ny
        do j = 0, half_nx + 1
           x(i, j) = ranmar()
        enddo
      enddo
      return
      end 

CCCCCCCCC==========     MEASURE      ============CCCCCCCCCCCCC

      SUBROUTINE measure

      INCLUDE "def.h"
      INCLUDE "array.h"
      REAL t_gauss(half_nx, half_ny) 
      real tmp_gauss
      integer i, j 

      do i = 1, gny
         do j = 1, gnx
           t_gauss(i, j) = 0.5 *(t1(i,j)+t2(i,j)+t3(i,j)+t4(i,j))
         enddo 
      enddo 

      do i = 1, gny
         do j = 1, half_nx
            tmp_gauss = tmp_gauss + t_gauss(i,j)
         enddo
      enddo
      gauss = tmp_gauss + gauss

C      tmp_gauss = tmp_gauss/35.0

C      print *, tmp_gauss

      RETURN
      END

