C=============================================================
C
C     function: mimics cshift() of CMFortran
C     restrictions:  dimension = 2 and shift amount = +1/-1 
C     input : x 
C     output: y 
C
C=============================================================
      subroutine cshift (x, dimn, shift, y)
      include 'def.h'
      real x(half_ny, 0:half_nx+1)
      real y(half_ny, 0:half_nx+1)
      real temp_row(0:half_nx+1)
      real temp_col(half_ny)
      integer shift, dimn
      integer i, j

      if (dimn .eq. 1) then 
         if (shift .eq. 1) then
            do j = 0, half_nx + 1
               temp_row(j) = x(1, j)
            enddo
            do i= 1, half_ny-1
               do j = 0, half_nx + 1
                  y(i, j) = x(i+1, j)
               enddo
            enddo
            do j = 0, half_nx + 1
               y(half_ny, j) = temp_row(j)
            enddo
         else  
            do j = 0, half_nx + 1
               temp_row(j) = x(half_ny, 1)
            enddo
            do i= half_ny, 2, -1
               do j = 0, half_nx + 1
                  y(i, j) = x(i-1, j)
               enddo
            enddo
            do j = 0, half_nx + 1
               y(1, j) = temp_row(j)
            enddo
         endif
      else if (dimn .eq. 2) then 
         if (shift .eq. 1) then 
            do i = 1, half_ny
               temp_col(i) = x(i, 0)
            enddo
            do j = 0, half_nx
               do i = 1, half_ny
                  y(i, j) = x(i, j+1)
               enddo
            enddo
            do i = 1, half_ny
               y(i, half_nx+1) = temp_col(i)
            enddo
         else 
            do i = 1, half_ny
               temp_col(i) = x(i, half_nx+1)
            enddo
            do j = half_nx+1, 1, -1
               do i = 1, half_ny
                  y(i, j) = x(i, j-1)
               enddo
            enddo
            do i = 1, half_ny
               y(i, 1) = temp_col(i)
            enddo
         endif 
      endif
      return
      end 
C=============================================================
C     function: collecs several messages into big chunks and
C               performs receives and sends
C=============================================================
      subroutine communicate(indir, outdir, x1, x2, x3, x4)
      include 'def.h'
      integer indir, outdir
      real x1(half_ny, 0:half_nx+1)
      real x2(half_ny, 0:half_nx+1)
      real x3(half_ny, 0:half_nx+1)
      real x4(half_ny, 0:half_nx+1)
      integer i, j, k

      do i=      1,gny 
         outbuf(i) = x1(i, gnx) 
      enddo
      do i=  gny+1,2*gny 
         outbuf(i) = x2(i, gnx) 
      enddo
      do i=2*gny+1,3*gny 
         outbuf(i) = x3(i, gnx) 
      enddo
      do i=3*gny+1,4*gny 
         outbuf(i) = x4(i, gnx) 
      enddo
C     print *, "sending x! "
C     if (my_pnum .eq. 0) print *,'I am p#0, i sent    :', outbuf(1:10)
      do i = 0, 31
         if (my_pnum .eq. i)
     &      ret_stat =cmmd_send_and_receive(indir, tag, inbuf, 
     &          4*gny, outdir, tag, outbuf, 4*gny)
      enddo
C     print *, "received x ! "
C     if (my_pnum .eq. 1) print *,'I am p#1, i received:', inbuf(1:10)
      k = 1
      do i =1, gny
         x1(k, gnx+1) = inbuf(i)
         k = k + 1
      enddo
      do i = gny+1, 2*gny
         x2(k, gnx+1) = inbuf(i)
         k = k + 1
      enddo 
      k = 1
      do i = 2*gny+1, 3*gny
         x3(k, gnx+1) = inbuf(i)
         k = k + 1
      enddo 
      k = 1
      do i = 3*gny+1, 4*gny
         x4(k, gnx+1) = inbuf(i)
         k = k + 1
      enddo
      return
      end
