CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                  C
C     Monte Carlo simulation of dynamically                        C
C     triangularized random surfaces.                              C
C     MIMD -Intel Versions RB 1993                                 C
C                                                                  C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     About This version                                           C
C     This is the MIMD Implementation of sequential code developed C
C     by LH. This program simulates Regular Fixed random Surfaces  C
C     Version 0.1 May 21 1993   RB                                 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      PROGRAM regular_surface_mimd

      INCLUDE 'reg.h'
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC

      integer i
      real*8 error1, error2,dummy
      double precision start,stop, time
      external sumup


	CALL KXINIT
        CALL KXPARA(ENV)

      iam = ENV(1) 

      CALL init

      if ( iam .eq. 0) then
         print *,'Input is done.The program is running. Please wait ...'
      endif


      DO i = 1, thermalization_sweeps
        CALL update_sites
      END DO

      if ( iam .eq. 0) then
         print *,'Thermalization over'
      endif

      DO i = 1, sweeps 
        CALL update_sites
        CALL measure
        CALL average
        if ( mod(i, 100) .eq. 0) then

      print *,'Sweep is',i

      print *, "Gauss average of", n," sites is : ",
     $          ave_gauss, "  +/- ", error1
      print *, "Site update acceptance rate is :", 
     $         ave_accept_rate, "+/- ", error2
 
      print *,'-----------------------------------'
        endif

      END DO



c      call gdsum(ave_gauss2,1,dummy)
c      call gdsum(ave_gauss,1,dummy)
c      call gdsum(ave_accept_rate2,1,dummy)
c      call gdsum(ave_accept_rate,1,dummy)

      istat = kxcomb(ave_gauss2,sumup,8,1,IALNOD,0,200)
      istat = kxcomb(ave_gauss,sumup,8,1,IALNOD,0,200)
      istat = kxcomb(ave_accept_rate2,sumup,8,1,IALNOD,0,200)
      istat = kxcomb(ave_accept_rate1,sumup,8,1,IALNOD,0,200)


      ave_gauss2 = ave_gauss2 /nprocs    
      ave_gauss = ave_gauss / nprocs     
      ave_accept_rate2 = ave_accept_rate2 / nprocs
      ave_accept_rate = ave_accept_rate / nprocs

        time = stop - start

      if ( iam .eq. 0) then

      error1 = (ave_gauss2 - ave_gauss)
      error2 = (ave_accept_rate2 - ave_accept_rate)

      print *, "Gauss average of", n," sites is : ",
     $          ave_gauss, "  +/- ", error1
      print *, "Site update acceptance rate is :", 
     $         ave_accept_rate, "+/- ", error2
      print *, 'Time taken is ',time,'seconds'
      endif

      print *,'The Program is over.'


      STOP
      END

C______________________________________________________________________

      subroutine init

      INCLUDE 'reg.h'
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC


      INTEGER idim,inx,iny,i,j,k,temp,istat,l
      INTEGER source_left, destination_right
      INTEGER source_right, destination_left
      INTEGER seed3, seed4,seed1,seed2
      REAL scale
      REAL ranmar


      iam = ENV(1) 



      
      seed3 = 14563
      print *, "Enter random seed3 ( between 0 and 31328 )",seed3


      seed4 = 23467
      print *, "Enter random seed4 ( between 0 and 31328 )",seed4


      thermalization_sweeps = 10
      print *, "Enter the number of sweeps for thermalization",
     &thermalization_sweeps


      sweeps = 600
      print *, "Enter the number of sweeps for update ?",sweeps


*     Setting up initial configuration
*     I am using Column-block distribution of the arrays

      seed1 = seed3 / seed_max
      seed2 = seed3 - (seed_max * seed1)

      call init_random (seed1, seed2)

      do i= 1, nx
         do j = 1, nyl
            do k = 1, 3
               field(i,j,k) = ranmar(istate)
c               print *,'local_coord is', local_coord(i,j,k)
            enddo
         enddo
      enddo

      k = 1
      do i=1, nx
         do j=1,3
            send_right(k) = field(i, nyl,j)
            send_left(k) = field(i,1,j)
            k = k+1
         enddo
      enddo

      if ( iam .eq. 0) then
         source_left = nprocs-1
      else
         source_left = iam -1
      endif

      destination_right = mod ( iam+1, nprocs)

      print *,'Before the call'

      call kmulti(6)
c      print *,'I',iam,'Sou',source_left,'dest',destination_right
      call kflush(6)

	istat = kxchan(recv_left,8*nxl,source_left,200,
     &     send_right,8*nxl,destination_right,200)


c      istat=isend(200,send_right,8*nxl,destination_right, 0)

c      call crecv(200,recv_left,8*nxl)

c      call msgwait(istat)

c        print *,'I am here'

      if ( iam .eq. 0) then
         destination_left = nprocs-1
      else
         destination_left = iam -1
      endif

      call kmulti(6)
c      print *,'I am here'
      call kflush(6)


      source_right = mod( iam+1, nprocs)

       istat = kxchan(recv_right,8*nxl,source_right,200,
     &     send_left,8*nxl,destination_left,200)


      call kmulti(6)
c      print *,'I am here'
      call kflush(6)


c      istat=isend(210,send_left,8*nxl,destination_left, 0)

c      call crecv(210,recv_right,8*nxl)

c      call msgwait(istat)

      k=1
      do i=1, nx
         do j=1, 3
            field(i,0,j)=recv_left(k)
            field(i,ydim,j) = recv_right(k)
            k= k+1
         enddo
      enddo


********* Coloring the local mesh using 4 colors 0,1,2 and 3

      iam = ENV(1)

      do i=1, nx
         do j=1, nyl
            k = mod(i,2)
            l = mod(j,2)
            if ((l .eq. 1) .and. (k .eq. 1)) then
            color(i,j)=0
            elseif  ((l .eq. 1) .and. (k .eq. 0)) then
            color(i,j)=1
            elseif  ((l .eq. 0) .and. (k .eq. 1)) then
            color(i,j)=2
            elseif  ((l .eq. 0) .and. (k .eq. 0)) then 
            color(i,j)=3
            endif
c            print *,'color', color(i,j),'iam',iam,i,j
         enddo
      enddo
********* done

c      print *,'I am',iam,'source',temp

      return
      end
C______________________________________________________________________

      subroutine update_sites

      INCLUDE 'reg.h'    
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC


      INTEGER inx, iny, i, j,k,l
      REAL ranmar
      REAL*8 trial_local_gauss, trial_x, trial_y, trial_z, diffE
      REAL*8 old_local_gauss, old_x, old_y, old_z
      REAL*8 a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12
      REAL*8 a13,a14,a15,a16,a17,a18

      INTEGER accept_counter,bound

      accept_counter = 0

      iam = ENV(1)

**    Note that I am having the grid from 0 to nyl+1 
**    hence y will go either to 0 or nyl+1 on boundry cases

      do j=0, 3

      bound = n/4

      do i =1, bound 

	     k = nx * ranmar(istate)
             l = nyl * ranmar(istate)
             
             do while ( color(k,j) .ne. j)
               k = nx * ranmar(istate)
               l = nyl * ranmar(istate)
             enddo

                    inx = k
                    iny = l

                    
      if ((inx .ne. 1) .or. (iny .ne. 1) .or.
     &( inx .ne. nx) .or. (iny .ne. nyl)) then
         xup = inx-1
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         yright = iny+1
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         yleft_down = iny-1
         xright_up = inx-1
         yright_up = iny+1

      elseif (iny .eq. 1) then

         yleft = 0
         yleft_down = 0
         xup = inx-1
         yup = iny
         xleft = inx
         xright = inx
         yright = iny+1
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         xright_up = inx-1
         yright_up = iny+1
       
      elseif ( inx .eq. 1) then
         xup = nx
         xright_up = nx
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         yright = iny+1
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         yleft_down = iny-1
         yright_up = iny+1
      
      elseif ( inx .eq. nx) then
         xdown =1
         xleft_down =1
         xup = inx-1
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         yright = iny+1
         ydown = iny
         yleft_down = iny-1
         xright_up = inx-1
         yright_up = iny+1

      elseif ( iny .eq. nyl) then
         yright = nyl+1
         yright_up = nyl+1
         xup = inx-1
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         yleft_down = iny-1
         xright_up = inx-1

        endif


       call kxsync()

      trial_x = field(inx,iny,1) + trial_scale *(ranmar(istate) - 0.5)
      trial_y = field(inx,iny,2) + trial_scale *(ranmar(istate) - 0.5)
      trial_z = field(inx,iny,3) + trial_scale *(ranmar(istate) - 0.5)

      old_x =  field(inx,iny,1)
      old_y =  field(inx,iny,2) 
      old_z =  field(inx,iny,3)


****If77 doesn't accept big expressions !

      a1= (trial_x - field(xup,iny,1)) ** 2  
      a2= (trial_y - field(xup,iny,2)) ** 2  
      a3= (trial_z - field(xup,iny,3)) ** 2  
      a4= (trial_x - field(xdown,iny,1)) ** 2  
      a5= (trial_y - field(xdown,iny,2)) ** 2  
      a6= (trial_z - field(xdown,iny,3)) ** 2
      a7= (trial_x - field(inx,yup,1)) ** 2  
      a8= (trial_y - field(inx,yup,2)) ** 2  
      a9= (trial_z - field(inx,yup,3)) ** 2  
      a10=(trial_x - field(inx,ydown,1)) ** 2  
      a11=(trial_y - field(inx,ydown,2)) ** 2  
      a12=(trial_z - field(inx,ydown,3)) ** 2
      a13= (trial_x - field(xright_up,yright_up,1)) ** 2  
      a14= (trial_y - field(xright_up,yright_up,2)) ** 2  
      a15= (trial_z - field(xright_up,yright_up,3)) ** 2  
      a16= (trial_x - field(xleft_down,yleft_down,1)) ** 2  
      a17= (trial_y - field(xleft_down,yleft_down,2)) ** 2  
      a18= (trial_z - field(xleft_down,yleft_down,3)) ** 2  

      trial_local_gauss = a1+a2+a3+a4+a5+a6+a7+a8+a9+a10+
     & a11+a12+a13+a14+a15+a16+17+a18

      a1= (old_x - field(xup,iny,1)) ** 2  
      a2= (old_y - field(xup,iny,2)) ** 2  
      a3= (old_z - field(xup,iny,3)) ** 2  
      a4= (old_x - field(xdown,iny,1)) ** 2  
      a5= (old_y - field(xdown,iny,2)) ** 2  
      a6= (old_z - field(xdown,iny,3)) ** 2
      a7= (old_x - field(inx,yup,1)) ** 2  
      a8= (old_y - field(inx,yup,2)) ** 2  
      a9= (old_z - field(inx,yup,3)) ** 2  
      a10=(old_x - field(inx,ydown,1)) ** 2  
      a11=(old_y - field(inx,ydown,2)) ** 2  
      a12=(old_z - field(inx,ydown,3)) ** 2
      a13= (old_x - field(xright_up,yright_up,1)) ** 2  
      a14= (old_y - field(xright_up,yright_up,2)) ** 2  
      a15= (old_z - field(xright_up,yright_up,3)) ** 2  
      a16= (old_x - field(xleft_down,yleft_down,1)) ** 2  
      a17= (old_y - field(xleft_down,yleft_down,2)) ** 2  
      a18= (old_z - field(xleft_down,yleft_down,3)) ** 2  

      old_local_gauss = a1+a2+a3+a4+a5+a6+a7+a8+a9+a10+
     & a11+a12+a13+a14+a15+a16+17+a18

C     Metroplis procedure

            diffE =  trial_local_gauss - old_local_gauss
            IF (diffE .GE. 0) THEN
               IF (exp(-diffE) .LT. ranmar(istate)) goto 22
            END IF
            field(inx,iny,1) = trial_x
            field(inx,iny,2) = trial_y
            field(inx,iny,3) = trial_z
            accept_counter = accept_counter+1

 22         continue
            
          
        enddo

       call pack_comm_copy


       enddo


      accept_rate = float(accept_counter)/n
      
c      print *,'I am done in node', iam

      call kxsync()

       return
       end
C______________________________________________________________________

      subroutine pack_comm_copy

      INCLUDE 'reg.h'
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC

      INTEGER idim,inx,iny,i,j,k,temp,istat,l
      INTEGER source_left, destination_right
      INTEGER source_right, destination_left


      iam = ENV(1)

      k = 1
      do i=1, nx
         do j=1,3
            send_right(k) = field(i, nyl,j)
            send_left(k) = field(i,1,j)
            k = k+1
         enddo
      enddo

      if ( iam .eq. 0) then
         source_left = nprocs-1
      else
         source_left = iam -1
      endif

      destination_right = mod ( iam+1, nprocs)

	istat = kxchan(recv_left,8*nxl,source_left,200,
     &     send_right,8*nxl,destination_right,200)

        

c      istat= isend(200,send_right,8*nxl,destination_right,0)

c      call crecv(200,recv_left,8*nxl)

      call kmulti(6)
c      print *,'I am here'
      call kflush(6)


c      call msgwait(istat)

c      print *,'After 1st message',iam


      if ( iam .eq. 0) then
         destination_left = nprocs-1
      else
         destination_left = iam -1
      endif

      
      source_right = mod( iam+1, nprocs)

       istat = kxchan(recv_right,8*nxl,source_right,200,
     &     send_left,8*nxl,destination_left,200)

      call kmulti(6)
c     print *,'I am here'
      call kflush(6)



c      istat= isend(200,send_left,8*nxl,destination_left, 0)

c      call crecv(200,recv_right,8*nxl)

c      call msgwait(istat)

c      print *,'After 2nd Message',iam

      k=1
      do i=1, nx
         do j=1, 3
            field(i,0,j)=recv_left(k)
            field(i,ydim,j) = recv_right(k)
            k= k+1
         enddo
      enddo

      return
      end
C______________________________________________________________________

      subroutine measure

      INCLUDE 'reg.h'
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC


      INTEGER inx, iny
      REAL*8  old_x, old_y, old_z
      REAL*8 a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12
      REAL*8 a13,a14,a15,a16,a17,a18


      gauss =0.0

      DO inx = 1, nx
      DO iny = 1, ny

      old_x =  field(inx,iny,1)
      old_y =  field(inx,iny,2) 
      old_z =  field(inx,iny,3)


      if ((inx .ne. 1).or.(iny .ne. 1) .or.
     & (inx .ne. nx).or.(iny .ne. nyl)) then
         xup = inx-1
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         yright = iny+1
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         yleft_down = iny-1
         xright_up = inx-1
         yright_up = iny+1

      elseif (iny .eq. 1) then

         yleft = 0
         yleft_down = 0
         xup = inx-1
         yup = iny
         xleft = inx
         xright = inx
         yright = iny+1
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         xright_up = inx-1
         yright_up = iny+1
       
      elseif ( inx .eq. 1) then

         xup = nx
         xright_up = nx
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         yright = iny+1
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         yleft_down = iny-1
         yright_up = iny+1
      
      elseif ( inx .eq. nx) then

         xdown =1
         xleft_down =1
         xup = inx-1
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         yright = iny+1
         ydown = iny
         yleft_down = iny-1
         xright_up = inx-1
         yright_up = iny+1

      elseif ( iny .eq. nyl) then

         yright = nyl+1
         yright_up = nyl+1
         xup = inx-1
         yup = iny
         xleft = inx
         yleft = iny-1
         xright = inx
         xdown = inx+1
         ydown = iny
         xleft_down = inx+1
         yleft_down = iny-1
         xright_up = inx-1

       endif

      a1= (old_x - field(xup,iny,1)) ** 2  
      a2= (old_y - field(xup,iny,2)) ** 2  
      a3= (old_z - field(xup,iny,3)) ** 2  
      a4= (old_x - field(xdown,iny,1)) ** 2  
      a5= (old_y - field(xdown,iny,2)) ** 2  
      a6= (old_z - field(xdown,iny,3)) ** 2
      a7= (old_x - field(inx,yup,1)) ** 2  
      a8= (old_y - field(inx,yup,2)) ** 2  
      a9= (old_z - field(inx,yup,3)) ** 2  
      a10=(old_x - field(inx,ydown,1)) ** 2  
      a11=(old_y - field(inx,ydown,2)) ** 2  
      a12=(old_z - field(inx,ydown,3)) ** 2
      a13= (old_x - field(xright_up,yright_up,1)) ** 2  
      a14= (old_y - field(xright_up,yright_up,2)) ** 2  
      a15= (old_z - field(xright_up,yright_up,3)) ** 2  
      a16= (old_x - field(xleft_down,yleft_down,1)) ** 2  
      a17= (old_y - field(xleft_down,yleft_down,2)) ** 2  
      a18= (old_z - field(xleft_down,yleft_down,3)) ** 2  

        gauss = gauss+a1+a2+a3+a4+a5+a6+a7+a8+a9+a10+
     & a11+a12+a13+a14+a15+a16+17+a18

      ENDDO
      ENDDO
      
c      print *,'gauss is',gauss

      gauss = 0.5 * gauss  ! because we have doubly summed each link
	gauss = gauss/6

      return
      end
C______________________________________________________________________

      subroutine average
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC

      INCLUDE 'reg.h'

      ave_gauss = ave_gauss + gauss/sweeps
      ave_gauss2 = ave_gauss + gauss*gauss/sweeps
      ave_accept_rate = ave_accept_rate + accept_rate/sweeps
      ave_accept_rate2 = ave_accept_rate + accept_rate**2/sweeps

      return
      end
C______________________________________________________________________
      
      subroutine init_random (seed1, seed2)
      
      include 'reg.h'
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      
      integer    ia, ic, im, x1_max, x2_max,seed1,seed2
      parameter (ia = 967)
      parameter (ic = 3041)
      parameter (im = 14406)
      parameter (x1_max = 31328)
      parameter (x2_max = 30081)
      
      integer    i97, j97, ii, jj
      integer  se1(0:nx),se2(0:nx),i(0:nx)
      integer  j(0:nx),k(0:nx),l(0:nx)
      integer  m(0:nx),temp1,temp2
      real     c,cd,cm
      real     u(0:nx,tdim)
      real     s(0:nx),t(0:nx)
      
      common /delta_urandom/   u
      common /delta_numbers/   c, cd, cm, i97, j97
      common /delta_coord/ xi,yi
           
           
           do ii = 0, nx
              seed1 = mod((seed1 * ia + ic), im)
              seed2 = mod((seed2 * ia + ic), im)
              se1(ii) = ((x1_max + 1) * seed1) / im
              se2(ii) = ((x2_max + 1) * seed2) / im
           enddo
           
           
           iam = ENV(1)
           
           xi = iam 
           
           i(xi) = mod(se1(xi)/177, 177) + 2
           j(xi) = mod(se1(xi),177) + 2
           k(xi) = mod(se2(xi)/169,178) + 1
           l(xi) = mod(se2(xi),169)
           
           do ii = 1, 97
              s(xi) = 0.0
              t(xi) = 0.5
              do jj = 1, 24
                 temp1 = i(xi)*j(xi)
	         m(xi) = mod(mod(temp1, 179)*k(xi), 179)
	         i(xi) = j(xi)
	         j(xi) = k(xi)
 	         k(xi) = m(xi)
	         l(xi) = mod(53*l(xi)+1, 169)
                 temp2=l(xi)*m(xi)
                 if( mod(temp2, 64) .ge. 32 )then
                    s(xi) = s(xi) + t(xi)
                 endif
                 t(xi) = 0.5 * t(xi)
              enddo
              u(xi,ii) = s(xi)
           enddo
           c   = 362436.0   / 16777216.0
           cd  = 7654321.0  / 16777216.0
           cm  = 16777213.0 / 16777216.0
           i97 = 97
           j97 = 33
           
           return
           end
C___________________________________________________________

        real function ranmar(state)


        include 'reg.h'
        COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC

        integer state
    	integer  i97, j97, ii, jj
    	real     c, cd, cm,rt
        real u(0:nx,97)
        real r(0:nx)

    	common /delta_urandom/   u
    	common /delta_rrandom/   r
  	common /delta_numbers/   c, cd, cm, i97, j97
        common /delta_coord/  xi,yi

        iam = ENV(1)
        xi = iam 

	    rt = u(xi,i97) - u(xi,j97)
c            print *,'rt is in proc(stage 1)',rt,iam
	    if ( rt .lt. 0.0 ) then
              rt = rt + 1.0
            endif
	    u(xi,i97) = rt
	    i97 = i97 - 1
	    if ( i97 .eq. 0 ) i97 = 97
    	j97 = j97 - 1
    	if ( j97 .eq. 0 ) j97 = 97
    	c = c - cd
    	if ( c .lt. 0.0 ) c = c + cm
    	rt = rt - c
c        print *,'rt is in proc(stage 2)',rt,iam
    	if ( rt .lt. 0.0 ) then
           rt = rt + 1.0
        endif

        ranmar = rt
	    return
	    end

C__________________________________________________________________________


            integer function sumup(v1,v2,sum)
            real*8 v1,v2
            integer size

            v1 = v1+v2
            sumup =0

            return

            end

c___________________________________________________________________________
